/* ----------------------------------------------------------------------------
 * global variables
 * ---------------------------------------------------------------------------- */
var ns4             = false;
var ie4             = false;
var pre             = '';
var post            = '';
var post2           = '';
var sldEntries      = new Array();
var tpEntries       = new Array();
var slides          = new Array();
var offset          = null;
var actualTimestamp = 0;
var lastTimestamp   = 0;
var timerID         = null;
var slideIndex      = 0;
var oldSlideIndex   = 0;
var oldTimestamp    = 0;
var curSlideIndex   = 0;
var curPointerIndex = 0;
var MediaPlayer1    = null;

/* ----------------------------------------------------------------------------
 * Determine the browser
 * ---------------------------------------------------------------------------- */
function determineBrowser()
{
  // Netscape 4.x
  if (document.layers)
  {
    ns4   = true;
    ie4   = false;
    pre   = 'document.';
    post  = '';
    post2 = '';
    MediaPlayer1 = document.layers["realplayer1"].document.embeds["MediaPlayer1"];
  }
  // Internet Explorer 4.x or higher
  else if (document.all)
  {
    ns4   = false;
    ie4   = true;
    pre   = 'document.all.';
    post  = '.style';
    post2 = '';
    MediaPlayer1 = document.all.tags("embed")[0];
  }

  // Netscape 6.x ?
  var ns6 = false;
  var ua = navigator.userAgent.toLowerCase();
  var netscapebrowser = ( (ua.indexOf("mozilla") != -1) 
                       && (ua.indexOf("compatible") == -1) 
                       && (ua.indexOf("opera") == -1) );
  var av = navigator.appVersion;
  var version = av.substring(0, av.indexOf(" ")) *1;
  var version2 = av.substring(0, av.indexOf(".")) *1;
  if ( netscapebrowser && (version2 == 5) )
    ns6 = true;

  if (ns6)
    alert("Netscape 6 wird leider nicht untersttzt. Um die volle Funktionalitt nutzen zu knnen, benutzen Sie bitte Netscape Version 4.xx oder Internet Explorer ab Version 4.");
  if (!ns4 && !ie4  && !ns6)
    alert("Um die volle Funktionalitt nutzen zu knnen, benutzen Sie bitte Netscape Version 4.xx oder Internet Explorer ab Version 4.");
}

/* ----------------------------------------------------------------------------
 * Help functions for Netscape / Internet Explorer
 * ---------------------------------------------------------------------------- */
function doLoadVF()
{
  if (ie4)
  {
    var v1 = parent.indexframe.document.body.scrollHeight;
    var v2 = parent.indexframe.document.body.clientHeight;
    if((v1 - v2) > 0)
      parent.indexframe.document.all.indexthumbs.height = parent.indexframe.document.body.clientHeight-1;
  }
}

function doUnloadVF()
{
  if (ie4)
  {
    setTimeout("window.resizeBy(1,1)", 66);
  }
}

/* ----------------------------------------------------------------------------
 * Functions for new URLs
 * ---------------------------------------------------------------------------- */
function gotoImc()
{
  F1 = window.open("http://www.im-c.de","imc_AG");
}

function gotoLecturnity()
{
  F1 = window.open("http://www.lecturnity.de","Lecturnity");
}

/* ----------------------------------------------------------------------------
 * Functions for slides
 * ---------------------------------------------------------------------------- */
function slideInit()
{
  for(i = 0; i < sldEntries.length; i++)
    slides[i] = new Image();
}

function loadAllSlides()
{
  for(i = 0; i < sldEntries.length; i++)
    slides[i].src = sldEntries[i].url;
}

function previousSlide()
{
  var newSlidePosition = sldEntries[slideIndex].prevIndex;
  showSlide(newSlidePosition);
}

function nextSlide()
{
  var newSlidePosition = sldEntries[slideIndex].nextIndex;
  showSlide(newSlidePosition);
}

function gotoSlide(position)
{
  var numOfThumbs = sldEntries[sldEntries.length-1].slideNumber;
  var newSlidePosition = position;
  
  if (newSlidePosition > numOfThumbs)
    newSlidePosition = 0;
  if (newSlidePosition < 0)
    newSlidePosition = numOfThumbs;

  showSlide(newSlidePosition);
}

function showSlide(position)
{
  loadSlide(position);
  offset = sldEntries[position].slideTime;
  fastForward();
}

function loadSlide(position)
{
  // Hide the Telepointer
  var tp = eval(pre + 'telepointer' + post);
  tp.visibility = "hidden";

  activateSegment(position);
  setAnchor(position);
  setFormSelect(position);

  if (slides[position].src == "")
    slides[position].src = sldEntries[position].url;
 
  var sa = eval(pre + 'slidearea' + post2);
  sa.document.slide_field.src = slides[position].src;
}

/* ----------------------------------------------------------------------------
 * Player Control functions: play, stop, pause, seek
 * (independent from browser; change of layer)
 * ---------------------------------------------------------------------------- */
function play()
{
  playerControlPlay();
}

function stop()
{
  loadSlide(0);
  playerControlStop();
}

function pause()
{
  playerControlPause();
}

function seek(target)
{
  var actualTime = new Date();
  var newTimestamp = actualTime.getTime();
  var deltaTimestamp = newTimestamp - oldTimestamp;
  if (deltaTimestamp > 1000)
  {
    oldTimestamp = newTimestamp;
    playerControlSeek(target);
  }
  else
  {
    oldTimestamp = newTimestamp;
    // do nothing else
  }
}

/* ----------------------------------------------------------------------------
 * Player Control functions: play, stop, pause (seek => see below)
 * (for Netscape and Internet Explorer)
 * ---------------------------------------------------------------------------- */
function playerControlPlay()
{
  MediaPlayer1.DoPlay();
}

function playerControlStop()
{
  MediaPlayer1.DoStop();
}

function playerControlPause()
{
  MediaPlayer1.DoPause();
}

/* ----------------------------------------------------------------------------
 * Seek funktions
 * ---------------------------------------------------------------------------- */

function playerControlSeek(target)
{
  var n = sldEntries.length;
  var newTarget = 0;
  for(i = 0; i < n; i++)
  {
    newTarget = i;
    if (sldEntries[i].slideNumber == target)
      break;
  }
  offset = sldEntries[newTarget].slideTime;
   
  if (MediaPlayer1.CanPlay())
    MediaPlayer1.DoPlay();
  
  timerID = setInterval("fastForward()", 1000);
}

function fastForward()
{
  if (offset > 0)
    MediaPlayer1.SetPosition(Math.round(offset));
  else
    MediaPlayer1.SetPosition(0);
  
  if ( (MediaPlayer1.GetPlayState() == 5)   /*Seeking*/
    || (MediaPlayer1.GetPlayState() == 3)   /*Playing*/
    || (MediaPlayer1.GetPlayState() == 2) ) /*Buffering*/
  {
    clearInterval(timerID);
    timerID = null;
    offset = null;
  }
}  
  
/* ----------------------------------------------------------------------------
 * Get the Position of the RealMedia Player
 * and related functions
 * ---------------------------------------------------------------------------- */
function getRealMediaPosition()
{
  if (MediaPlayer1.GetPlayState() != 0)
    actualTimestamp = MediaPlayer1.GetPosition();
  else
    actualTimestamp = offset;

  if (actualTimestamp < lastTimestamp)
    resetCurrentIndices();

  lastTimestamp = actualTimestamp;
  
  setSlide(actualTimestamp);
  setTP(actualTimestamp);
  
  window.setTimeout("getRealMediaPosition()", 20);
}

function setSlide(msTime)
{
  var n = sldEntries.length - 1;
  for (i = curSlideIndex; i < n; i++)
  {
    if ((msTime >= sldEntries[i].slideTime) && (msTime < sldEntries[i+1].slideTime))
    {
      if (i != slideIndex)
      {
        loadSlide(i);
        curSlideIndex = i;
        break;
      }
    }
  }

  if (msTime >= sldEntries[n].slideTime)
  {
    if (n != slideIndex)
    {
      loadSlide(n);
      curSlideIndex = n;
    }
  }
}

function setAnchor(position)
{
  var numOfThumbs = sldEntries[sldEntries.length-1].slideNumber + 1;

  var slideNumberLeft = (sldEntries[position].slideNumber) - 1;
  if (slideNumberLeft < 0)
    slideNumberLeft = 0;
  var slideNumberRight = (sldEntries[position].slideNumber) + 2;
  if (slideNumberRight > numOfThumbs)
    slideNumberRight = numOfThumbs;

  var reference = "01Einfuehrung_indexframe.html#slide";

  var reference1 = reference + slideNumberLeft;
  var reference2 = reference + slideNumberRight;

  if (slideIndex < oldSlideIndex)
    parent.indexframe.location.href = reference1;
  else
    parent.indexframe.location.href = reference2;

  if (ns4)
    parent.indexframe.location.href = reference1;
}

function setFormSelect(position)
{
  var pos = sldEntries[position].slideNumber;
  
  if (ie4) // Internet Explorer
  {
    parent.viewframe.form1.select1.selectedIndex = pos;
  }
  else if (ns4) // Netscape
  {
    parent.viewframe.document.listbox.document.forms["form1"].select1.selectedIndex = pos;
  }
}

function setTP(msTime)
{
  var n = tpEntries.length - 1;
  for (i = curPointerIndex; i < n; i++)
  {
    if ((msTime >= tpEntries[i].tpTime) && (msTime < tpEntries[i+1].tpTime))
    {
     	showTP(i);
     	curPointerIndex = i;
     	break;
    }
  }

  if (msTime >= tpEntries[n].tpTime)
  {
    showTP(n);
    curPointerIndex = n;
  }
}

function showTP(idx)
{
  var tp = eval(pre + 'telepointer' + post);

  if (tpEntries[idx].isVisible == true)
  {
    tp.top = tpEntries[idx].y + 29;
    tp.left = tpEntries[idx].x + 390;
    tp.visibility = "visible";
  }
  else
    tp.visibility = "hidden";
}

function resetCurrentIndices()
{
  curSlideIndex = 0;
  curPointerIndex = 0;
}

/* ----------------------------------------------------------------------------
 * Highlight the actual thumbnail
 * ---------------------------------------------------------------------------- */
function activateSegment(segmentID)
{
  oldSlideIndex = slideIndex;
  slideIndex = segmentID;
  
  var numOfLayers = 2 * (sldEntries[sldEntries.length-1].slideNumber + 1);
  
  if (ie4 && parent.indexframe.document) // Internet Explorer
  {
    if (parent.indexframe.document.all.tags("div").length == numOfLayers)
    {
      eval("parent.indexframe.document.all.tags(\"div\")[\"slide" + (sldEntries[oldSlideIndex].slideNumber) + "\"].style.backgroundColor='#FFFFFF'");
      eval("parent.indexframe.document.all.tags(\"div\")[\"slide" + (sldEntries[slideIndex].slideNumber) + "\"].style.backgroundColor='#FFAA7B'");
      eval("parent.indexframe.document.all.tags(\"div\")[\"slide" + (sldEntries[oldSlideIndex].slideNumber) + "a\"].style.backgroundColor='#FFFFFF'");
      eval("parent.indexframe.document.all.tags(\"div\")[\"slide" + (sldEntries[slideIndex].slideNumber) + "a\"].style.backgroundColor='#FFAA7B'");
    }
  }
  else if (ns4 && parent.indexframe.document) // Netscape
  {
    if (parent.indexframe.document.layers.length == numOfLayers)
    {
      eval("parent.indexframe.document.slide" + (sldEntries[oldSlideIndex].slideNumber) + "a.bgColor='#FFFFFF'");
      eval("parent.indexframe.document.slide" + (sldEntries[slideIndex].slideNumber) + "a.bgColor='#FFAA7B'");
      eval("parent.indexframe.document.slide" + (sldEntries[oldSlideIndex].slideNumber) + ".bgColor='#FFFFFF'");
      eval("parent.indexframe.document.slide" + (sldEntries[slideIndex].slideNumber) + ".bgColor='#FFAA7B'");
    }
  }
}

/* ----------------------------------------------------------------------------
 * Init
 * ---------------------------------------------------------------------------- */
function init()
{
  determineBrowser();
  sldEntriesInit();
  tpEntriesInit();
  slideInit();
  loadAllSlides();
  loadSlide(0);
  getRealMediaPosition();
  //play();
}

/* ----------------------------------------------------------------------------
 * The "sldEntry" object
 * ---------------------------------------------------------------------------- */
function sldEntry(slideNumber, slideTime, url, pagingIndex, prevIndex, nextIndex)
{
  this.slideNumber = slideNumber;
  this.slideTime = slideTime;
  this.url = url;
  this.pagingIndex = pagingIndex;
  this.prevIndex = prevIndex;
  this.nextIndex = nextIndex;
}

/* ----------------------------------------------------------------------------
 * Create instances of the "sldEntry" object
 * ---------------------------------------------------------------------------- */
function sldEntriesInit()
{
  sldEntries[0] = new sldEntry(0, 0, "01Einfuehrung_00000000.png", 0, 8, 1);
  sldEntries[1] = new sldEntry(1, 12529, "01Einfuehrung_00012529.png", 1, 0, 2);
  sldEntries[2] = new sldEntry(2, 1048317, "01Einfuehrung_01048317.png", 2, 1, 3);
  sldEntries[3] = new sldEntry(3, 1051617, "01Einfuehrung_01051617.png", 3, 2, 4);
  sldEntries[4] = new sldEntry(4, 1060247, "01Einfuehrung_01060247.png", 4, 3, 5);
  sldEntries[5] = new sldEntry(5, 1109840, "01Einfuehrung_01109840.png", 5, 4, 6);
  sldEntries[6] = new sldEntry(6, 1142832, "01Einfuehrung_01142832.png", 6, 5, 7);
  sldEntries[7] = new sldEntry(7, 1229200, "01Einfuehrung_01229200.png", 7, 6, 8);
  sldEntries[8] = new sldEntry(8, 1256513, "01Einfuehrung_01256513.png", 8, 7, 0);
  sldEntries[9] = new sldEntry(8, 1374249, "01Einfuehrung_01374249.png", 8, 7, 0);
}

/* ----------------------------------------------------------------------------
 * The "tpEntry" object
 * ---------------------------------------------------------------------------- */
function tpEntry(tpTime, x, y, isVisible)
{
  this.tpTime = tpTime;
  this.x = x;
  this.y = y;
  this.isVisible = isVisible;
}

/* ----------------------------------------------------------------------------
 * Create instances of the "tpEntry" object
 * ---------------------------------------------------------------------------- */
function tpEntriesInit()
{
  tpEntries[0] = new tpEntry(0, 0, 0, false);
}
